(* Copyright 2008, 2009 Michael Brunner *)

(* This file is part of LIPS.

  LIPS is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as 
	published by the Free Software Foundation, either version 3 of 
	the License, or (at your option) any later version.

  LIPS is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public 
	License along with LIPS.  If not, see 
	<http://www.gnu.org/licenses/>. *)

type t = Var of int | Arrow of t * t | TCons of Strng.t * t list
type env = (CoreML.t * t) St.t

val var : int -> t
val arrow : t -> t -> t
val tcons : Strng.t -> t list -> t
val tcons' : string -> t list -> t

val bool : t
val int : t
val basic_env : (CoreML.t * t) St.t

val reduce_var_index : t -> t

val is_unifiable : (t * t) St.t -> bool
val check_type : (CoreML.t * t) St.t -> CoreML.t -> t -> bool
val is_typable : (CoreML.t * t) St.t -> CoreML.t -> bool
val infer_type : (CoreML.t * t) St.t -> CoreML.t -> t

val typep : t Parser.t

val to_strng : t -> Strng.t
val to_string : t -> string
val toplevel_printer : Format.formatter -> t -> unit
